Subject: [Lwip] new version for draft-chen-lwip-implementataion-00.txt

From: Zhen Cao <[email-masked]>
Date: Tue, 9 Nov 2010 16:27:24 +0800

Hi all,

I found a new version of this draft posted, with more detailed
information inside:

http://www.ietf.org/id/draft-chen-lwip-implementataion-01.txt

On Tue, Oct 19, 2010 at 1:00 AM, Zhen Cao <[email-masked]> wrote:
> FYI, a draft on implementation techniques for lwip.
>
>
> ---------- Forwarded message ----------
> From:  <[email-masked]>
> Date: Tue, Oct 19, 2010 at 12:00 AM
> Subject: I-D Action:draft-chen-lwip-implementataion-00.txt
> To: [email-masked]
>
>
> A New Internet-Draft is available from the on-line Internet-Drafts directories.
>
>        Title           : Implementation Techniques of the Lightweight
> TCP/IP Stack
>        Author(s)       : W. Chen
>        Filename        : draft-chen-lwip-implementataion-00.txt
>        Pages           : 11
>        Date            : 2010-10-18
>
> Since small devices such as sensors are often required to be
> physically small and inexpensive, an implementation of the Internet
> protocols will have to deal with having limited computing resources
> and memory.  This report describes the design and implementation of a
> small TCP/IP stack called lwIP that is small enough to be used in
> minimal systems.
>
> A URL for this Internet-Draft is:
> http://www.ietf.org/internet-drafts/draft-chen-lwip-implementataion-00.txt
>
> Internet-Drafts are also available by anonymous FTP at:
> ftp://ftp.ietf.org/internet-drafts/
>
> Below is the data which will enable a MIME compliant mail reader
> implementation to automatically retrieve the ASCII version of the
> Internet-Draft.
>
>
> _______________________________________________
> I-D-Announce mailing list
> [email-masked]
> https://www.ietf.org/mailman/listinfo/i-d-announce
> Internet-Draft directories: http://www.ietf.org/shadow.html
> or ftp://ftp.ietf.org/ietf/1shadow-sites.txt
>
>
>
>
> --
> Best regards,
> Zhen
>

-- 
Best regards,
Zhen

---

From: JP Vasseur <[email-masked]>
Date: Wed, 10 Nov 2010 21:59:45 +0800

Hi,

As I said, I would like to express my strong support for a new WG, in light of the proposed 
new charter. On this particular ID, I must say that I read several statements that go in my
in the opposite direction of what the WG should be doing (analysis of existing IP protocols, 
determine potential optimizations, use of options, feed-back to existing WG, ...).

Reading this:

1.  Non-layered protocols

   With the era of the Internet of Things, the applications of smart
   objects are more and more widely used.  Smart objects are usually
   low- power and have limited memory communication capabilities.  In
   the past, they usually communicated through a protocol-translation
   gateway, which is typically of non-IP architecture.  However,
   protocol gateways are inherently complex to design, manage, and
   deploy.  It requests for scalability, interoperability and solid
   standardization based networking technology to support a large number
   of applications of smart objects.  It is well known that IP is a
   stable, long-lived and highly scalable communication technology.  So
   it can support a wide range of applications, devices, and underlying
   communication technologies.

   As smart objects will connect a larger number of devices than any
   other existing Internet, scalability is critical.  The next
   generation Internet protocol, IPv6, expands the address space of IP
   to 2^128, which has been said to be enough to provide every grain of
   sand on the planet with an IP address.  In addition, the advantage of
   Plug and Play, security, QoS, mobility of IPv6 make it better to meet
   the needs of smart objects connecting.

So far so good 
   However, IPv6 cannot be directly applied in the smart device.  It
   requests for correspondingly simplifying the IPv6 protocol stacks and
   routing mechanisms to meet the requirements of network with low power
   consumption, low storage capacity and low transfer rate.  This
   document introduces the design and implementation of the Lightweight
   TCP/IP Stack, and the problems met by implementers.

If that were true, this would mean that the WGs having delivered IPv6 protocols
for IP smart objects networks would have failed ... These protocols HAVE been
defined by several WG that these constraints in mind: CoAP, 6lowpanND, RPL,...

On the other hand, looking at other existing protocols with the objective to see which
options should be used and how lightweight implementations and optimizations of these 
protocols could be performed is I think extremely useful.

3.  Non-layered protocols

   In most common cases, TCP/IP protocols are implemented by modularity
   and layering.  But for the constraint systems, layering will increase
   the cost so as to affect the overall performance.  Moreover, there is
   no strict barrier between the kernel and application processes, such
   as TinyOS and Contiki.

   So there is no strict layer in Lightweight TCP/IP protocols, which
   are designed to be tight-coupled in order to shorten the codes and
   save the memory.  Non-layered protocols can be implemented by queue
   method to cache the packages.

A very slippery slope, at least something I would STRONGLY disagree with.

Cross-layer optimizations could be interesting, non-layered approach is completely different
and IMO the argument according which the absence of layers automatically leads to more
efficient implementation is very much bogus. Many IPv6 stacks do fit within a few K of RAM 
and dozen K fo flash. Could that be improved ? Certainly ! Should we look at this and provide
recommendations ? I also think so, thus my strong support for a WG but many of the statements
in this document are highly arguable in particular this one (3.).

Hope that helps.

JP.

On Nov 9, 2010, at 4:27 PM, Zhen Cao wrote:

> Lwip mailing list
> [email-masked]
> https://www.ietf.org/mailman/listinfo/lwip

---

From: Wenlong Chen <[email-masked]>
Date: Thu, 11 Nov 2010 14:56:32 +0800

Hi JP,

Thank you for your comments. We naturally present our ideas, not aimed to be
opposite of existing WGs, but regret to have caused some confusion due to
careless expression. As a matter of fact, we support these relative WGs,
like Core, Roll, and so on. We will cautiously consider the problems you
brought up.

Actually, we do not mean that IPv6 is failed to be in use, but rather make
further optimization to fit constrain devices better. Mainly designed for
protocol extension, many options are not commonly used currently. Thus it is
possible and meaningful to do some work here, as you mentioned, to find out
how options work with lightweight implementations.

In view of the messages, there is still strict layering relationships, as
well as the network system processing. As far as we are concerned, the
message queues between layers in traditional processing should be
simplified. Using functions will accomplish the network message delivering
and receiving process more effectively, making each layer work well.

Best regards.

Wenlong

---

From: Zhen Cao <[email-masked]>
Date: Thu, 11 Nov 2010 17:32:58 +0800

On Wed, Nov 10, 2010 at 9:59 PM, JP Vasseur <[email-masked]> wrote:
> new charter.

Good to know that.  Since the charter was decided after these
submitted document, they are not align as you pointed out.

I agree with all you stated below.  We will work on the document to
determine potential optimizations, use of options and etc.

> On this particular ID, I must say that I read several statements that go in my

-- 
Best regards,
Zhen